
 /* MEMORY.PRG  Tom Groeger 1993
    Sound & Vision for Clipper (c) Demonstration Code  */


  #include "SOUNDVIS.CH"
  #include "INKEY.CH"

  #define  F_WBLUE     31               // LiteWhite on Blue
  #define  F_NHB       48               // Black on LiteBlue
  #define  F_NW       112               // Black on White
  #define  F_RW       116               // Red on White
  #define  F_WBROWN   191               // LiteWhite on Brown (converted)
  #define  F_NBEIGE   208               // black on Beige     (converted)
  #define  F_RBEIGE   212               // red on Beige       (converted)



/*
    ShowMem () -> nil                                   
    Demofunction to track your Applications appetite    
    for Memory.                                         
    It shows the functions ISCPU () and ISVIDEO(),      
    and on top of it all the ( mostly undocumented )    
    MEMORY () calls                                     
  */


  FUNCTION ShowMem()

  LOCAL nCur := Setcursor(0)
  LOCAL cCol := SETCOLOR( '+GR/*RB')
  LOCAL nkey
  LOCAL cScreen
  LOCAL Getlist := {}
  
  OPENWIN FROM 3,15  TO 21,65      ;
          TITLE   'System-Info'    ;
          TYP      WIN_MESSAGE     ;
          TOPCOLOR F_WBROWN        ;
          WINCOLOR F_NBEIGE        ;
          SAVE TO  cScreen



 /* call complete Scavenge, this memory() call should be used
    with caution ( some people says it's even dangerous, although
    I have never experienced any problems .. judge yourself by
    calling this function with or without Memory(-1) */

    MEMORY(-1)

 // descriptions
 // -------------
    ShowStr ( 06, 20, 'CPU')
    ShowStr ( 07, 20, 'Video Adapter')
    ShowStr ( 09, 20, 'Conventional Memory      KByte' )  //Mem(0)
    ShowStr ( 10, 20, 'Free Swap-Memory         KByte' )  //Mem(0)+MEM(103)
    ShowStr ( 11, 20, 'Largest StringObject     KByte' )  //Mem(1)
    ShowStr ( 12, 20, 'Free Run-Memory          KByte' )  //Mem(2)
    ShowStr ( 13, 20, 'String/Array Memory      KByte' )  //Mem(3)
    ShowStr ( 14, 20, 'Available EMS-Memory     KByte' )  //Mem(4)+(105)
    ShowStr ( 15, 20, 'Locked Heap-Segments     KByte' )  //Mem(101)
    ShowStr ( 16, 20, 'Segments in Heap' )                //Mem(102)
    ShowStr ( 17, 20, 'Unused Conv. Memory      KByte' )  //Mem(104)

 // show memory() returns
 // ----------------------
    @ 06,53 SAY IsCpu ( .t.)
    @ 07,49 SAY IsVideo(.t.)

    @ 09,53 SAY MEMORY(0)             PICT '99999'
    @ 10,53 SAY MEMORY(0)+MEMORY(103) PICT '99999'
    @ 11,53 SAY MEMORY(1)             PICT '99999'
    @ 12,53 SAY MEMORY(2)             PICT '99999'
    @ 13,53 SAY MEMORY(3)             PICT '99999'

    @ 14,53 SAY MEMORY(4)+MEMORY(105) PICT '99999'
    @ 15,53 SAY MEMORY(101)           PICT '99999'
    @ 16,53 SAY MEMORY(102)           PICT '99999'
    @ 17,53 SAY MEMORY(104)           PICT '99999'

 // draw button
 // -------------
    nkey := 1
    @ 19, 34 GET nkey AS PUSHBUTTON {'  ~OK  '}  ;
             COLOR F_NW  HOTKEY F_RW
    READ

    SETCOLOR(cCol)
    SETCURSOR(nCur)
    ScrRest(cScreen)

 RETURN( NIL )

